/*
 * @Description  : 
 * @Version      : 1.0
 * @Author       : Shiming
 * @Date         : 2021-12-29 14:51:07
 * @LastEditors  : Shiming
 * @LastEditTime : 2022-01-18 17:23:46
 * @FilePath     : \\tms-obc-web\\src\\app\\routes\\order-management\\modal\\vehicle\\modify-rate\\modify-rate.component.ts
 * Copyright (C) 2022 huzhenhong. All rights reserved.
 */

import { Component, Input, OnInit, ViewChild } from '@angular/core';
import { SFComponent, SFNumberWidgetSchema, SFSchema, SFUISchema } from '@delon/form';
import { NzMessageService } from 'ng-zorro-antd/message';
import { NzModalRef } from 'ng-zorro-antd/modal';
import { OrderManagementService } from '../../../services/order-management.service';

@Component({
  selector: 'app-order-management-vehicle-modify-rate',
  templateUrl: './modify-rate.component.html',
  styleUrls: ['./modify-rate.component.less']
})
export class VehicleModifyRateComponent implements OnInit {
  @ViewChild('sf', { static: false }) sf!: SFComponent;
  schema: SFSchema = {};
  ui: SFUISchema = {};

  aggreechecked = false;

  @Input()
  data: any;

  constructor(private modal: NzModalRef, private msgSrv: NzMessageService, public service: OrderManagementService) {}

  ngOnInit(): void {
    console.log(this.data);
    this.initSF();
  }
  initSF() {
    this.schema = {
      properties: {
        additionalRate: {
          type: 'number',
          title: '附加费率',
          ui: {
            unit: '%',
            widgetWidth: 200,
            precision: 2
          } as SFNumberWidgetSchema
        }
      },
      required: ['additionalRate']
    };
    this.ui = {
      '*': {
        spanLabelFixed: 100,
        grid: { span: 16 }
      }
    };
  }

  save(value: any): void {
    if (!this.sf.value?.additionalRate) {
      this.service.msgSrv.warning('请填写附加费！');
      return;
    }
    console.log(this.sf.value);
    const params = {
      ids: this.data?.ids,
      ...this.sf.value
    };
    console.log(params);
    this.service.request(this.service.$api_set_updateAdditionalRateBatch, params).subscribe((res: any) => {
      if (res) {
        this.modal.close(true);
        this.service.msgSrv.success('变更运费成功');
      } else {
        this.service.msgSrv.error(res?.msg);
      }
    });
  }

  close(): void {
    this.modal.destroy();
  }
}
